# -*- coding: utf-8 -*- 
import os, os.path, wx, wx.xrc , string, re, sys, datetime, fileinput, re, shutil, csv, re
from ConfigParser import SafeConfigParser

class Merchelper ( wx.Frame ):

	def __init__( self, parent ):
		wx.Frame.__init__ ( self, parent, id = wx.ID_ANY, title = wx.EmptyString, pos = wx.DefaultPosition, size = wx.Size( 631,405 ), style = wx.DEFAULT_FRAME_STYLE|wx.TAB_TRAVERSAL )
		
		self.SetSizeHintsSz( wx.DefaultSize, wx.DefaultSize )
		
		bSizer30 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer1 = wx.BoxSizer( wx.VERTICAL )
		
		self.m_notebook1 = wx.Notebook( self, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_panel2 = wx.Panel( self.m_notebook1, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer20 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer7 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer3211 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText1211 = wx.StaticText( self.m_panel2, wx.ID_ANY, u"Artist Name      ", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText1211.Wrap( -1 )
		bSizer3211.Add( self.m_staticText1211, 0, wx.ALL, 5 )
		
		self.ctl_artName = wx.TextCtrl( self.m_panel2, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer3211.Add( self.ctl_artName, 1, wx.ALL, 5 )
		
		self.m_include = wx.CheckBox( self.m_panel2, wx.ID_ANY, u"Include in title", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_include.SetValue(False) 
		bSizer3211.Add( self.m_include, 0, wx.ALL, 5 )
		
		bSizer7.Add( bSizer3211, 1, wx.EXPAND, 5 )
		
		bSizer33 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText13 = wx.StaticText( self.m_panel2, wx.ID_ANY, u"Artist Email       ", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText13.Wrap( -1 )
		bSizer33.Add( self.m_staticText13, 0, wx.ALL, 5 )
		
		self.ctl_Email = wx.TextCtrl( self.m_panel2, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer33.Add( self.ctl_Email, 1, wx.ALL, 5 )
		
		bSizer7.Add( bSizer33, 0, wx.EXPAND, 5 )
		
		bSizer321 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText121 = wx.StaticText( self.m_panel2, wx.ID_ANY, u"Product Name ", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText121.Wrap( -1 )
		bSizer321.Add( self.m_staticText121, 0, wx.ALL, 5 )
		
		self.ctl_productName = wx.TextCtrl( self.m_panel2, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer321.Add( self.ctl_productName, 1, wx.ALL, 5 )
		
		bSizer7.Add( bSizer321, 1, wx.EXPAND, 5 )
		
		bSizer32 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText12 = wx.StaticText( self.m_panel2, wx.ID_ANY, u"Creation Date   ", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText12.Wrap( -1 )
		bSizer32.Add( self.m_staticText12, 0, wx.ALL, 5 )
		
		self.ctl_creationDate = wx.TextCtrl( self.m_panel2, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer32.Add( self.ctl_creationDate, 1, wx.ALL, 5 )
		
		bSizer7.Add( bSizer32, 0, wx.EXPAND, 5 )
		
		bSizer20.Add( bSizer7, 0, wx.EXPAND, 5 )
		
		bSizer12 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer38 = wx.BoxSizer( wx.HORIZONTAL )
		
		bSizer38.AddSpacer( ( 0, 0), 1, wx.EXPAND, 5 )
		
		self.m_save_details = wx.Button( self.m_panel2, wx.ID_ANY, u"Save Personal Details", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer38.Add( self.m_save_details, 0, wx.RIGHT, 5 )
		
		bSizer12.Add( bSizer38, 0, wx.EXPAND, 5 )
		
		bSizer37 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText6 = wx.StaticText( self.m_panel2, wx.ID_ANY, u"Product Description", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText6.Wrap( -1 )
		bSizer37.Add( self.m_staticText6, 0, wx.ALL, 5 )
		
		self.ctl_product_description = wx.TextCtrl( self.m_panel2, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, wx.TE_MULTILINE|wx.TE_WORDWRAP )
		bSizer37.Add( self.ctl_product_description, 1, wx.ALL|wx.EXPAND, 5 )
		
		bSizer12.Add( bSizer37, 1, wx.EXPAND, 5 )
		
		bSizer20.Add( bSizer12, 1, wx.EXPAND, 5 )
		
		self.m_panel2.SetSizer( bSizer20 )
		self.m_panel2.Layout()
		bSizer20.Fit( self.m_panel2 )
		self.m_notebook1.AddPage( self.m_panel2, u"Basic Info", True )
		self.m_panel1 = wx.Panel( self.m_notebook1, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer13 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer22 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText11 = wx.StaticText( self.m_panel1, wx.ID_ANY, u"Poser Version", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText11.Wrap( -1 )
		bSizer22.Add( self.m_staticText11, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer22, 0, wx.EXPAND, 5 )
		
		bSizer23 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_poser4 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"P4", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer23.Add( self.m_poser4, 0, wx.ALL, 5 )
		
		self.m_poser5 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"P5", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer23.Add( self.m_poser5, 0, wx.ALL, 5 )
		
		self.m_poser6 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"P6", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer23.Add( self.m_poser6, 0, wx.ALL, 5 )
		
		self.m_poser7 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"P7", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer23.Add( self.m_poser7, 0, wx.ALL, 5 )
		
		self.m_poser8 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"P8", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer23.Add( self.m_poser8, 0, wx.ALL, 5 )
		
		self.m_poser9 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"P9", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer23.Add( self.m_poser9, 0, wx.ALL, 5 )
		
		self.m_poser10 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"P10+", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer23.Add( self.m_poser10, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer23, 0, wx.EXPAND, 5 )
		
		bSizer24 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_ds3 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"Daz Studio (up to 3)", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer24.Add( self.m_ds3, 0, wx.ALL, 5 )
		
		self.m_ds4 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"Daz Studio 4+", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer24.Add( self.m_ds4, 0, wx.ALL, 5 )
		
		self.m_bryce = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"Bryce", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer24.Add( self.m_bryce, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer24, 0, wx.EXPAND, 5 )
		
		bSizer25 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText122 = wx.StaticText( self.m_panel1, wx.ID_ANY, u"Vue Version", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText122.Wrap( -1 )
		bSizer25.Add( self.m_staticText122, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer25, 0, wx.EXPAND, 5 )
		
		bSizer26 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_vue5 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"V5", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer26.Add( self.m_vue5, 0, wx.ALL, 5 )
		
		self.m_vue6 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"V6", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer26.Add( self.m_vue6, 0, wx.ALL, 5 )
		
		self.m_vue7 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"V7", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer26.Add( self.m_vue7, 0, wx.ALL, 5 )
		
		self.m_vue8 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"V8", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer26.Add( self.m_vue8, 0, wx.ALL, 5 )
		
		self.m_vue9 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"V9", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer26.Add( self.m_vue9, 0, wx.ALL, 5 )
		
		self.m_vue10 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"V10", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer26.Add( self.m_vue10, 0, wx.ALL, 5 )
		
		self.m_vue11 = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"V11+", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer26.Add( self.m_vue11, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer26, 0, wx.EXPAND, 5 )
		
		bSizer27 = wx.BoxSizer( wx.VERTICAL )
		
		self.m_staticText131 = wx.StaticText( self.m_panel1, wx.ID_ANY, u"2D Paint", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText131.Wrap( -1 )
		bSizer27.Add( self.m_staticText131, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer27, 0, wx.EXPAND, 5 )
		
		bSizer28 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_photoshop = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"PhotoShop", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer28.Add( self.m_photoshop, 0, wx.ALL, 5 )
		
		self.m_psp = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"Paint Shop Pro", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer28.Add( self.m_psp, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer28, 0, wx.EXPAND, 5 )
		
		bSizer48 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_PC = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"PC", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer48.Add( self.m_PC, 0, wx.ALL, 5 )
		
		self.m_MAC = wx.CheckBox( self.m_panel1, wx.ID_ANY, u"MAC", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer48.Add( self.m_MAC, 0, wx.ALL, 5 )
		
		bSizer13.Add( bSizer48, 0, wx.EXPAND, 5 )
		
		bSizer29 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText14 = wx.StaticText( self.m_panel1, wx.ID_ANY, u"Other", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText14.Wrap( -1 )
		bSizer29.Add( self.m_staticText14, 0, wx.ALL, 5 )
		
		self.ctl_other = wx.TextCtrl( self.m_panel1, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer29.Add( self.ctl_other, 1, wx.ALL|wx.EXPAND, 5 )
		
		bSizer13.Add( bSizer29, 0, wx.EXPAND, 5 )
		
		self.m_panel1.SetSizer( bSizer13 )
		self.m_panel1.Layout()
		bSizer13.Fit( self.m_panel1 )
		self.m_notebook1.AddPage( self.m_panel1, u"Compatibility", False )
		self.m_panel5 = wx.Panel( self.m_notebook1, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer34 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer35 = wx.BoxSizer( wx.HORIZONTAL )
		
		m_mrChoices = [ u"Yes", u"No" ]
		self.m_mr = wx.RadioBox( self.m_panel5, wx.ID_ANY, u"Was this Product made with a Merchant Resource?", wx.DefaultPosition, wx.DefaultSize, m_mrChoices, 1, wx.RA_SPECIFY_COLS )
		self.m_mr.SetSelection( 1 )
		bSizer35.Add( self.m_mr, 1, wx.ALL, 5 )
		
		bSizer34.Add( bSizer35, 0, wx.EXPAND, 5 )
		
		bSizer36 = wx.BoxSizer( wx.VERTICAL )
		
		self.m_staticText15 = wx.StaticText( self.m_panel5, wx.ID_ANY, u"If Yes please list ALL resources used,", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText15.Wrap( -1 )
		bSizer36.Add( self.m_staticText15, 0, wx.ALL, 5 )
		
		self.ctl_resources = wx.TextCtrl( self.m_panel5, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, wx.TE_MULTILINE|wx.TE_WORDWRAP )
		self.ctl_resources.Enable( False )
		
		bSizer36.Add( self.ctl_resources, 1, wx.ALL|wx.EXPAND, 5 )
		
		bSizer34.Add( bSizer36, 1, wx.EXPAND, 5 )
		
		bSizer37 = wx.BoxSizer( wx.VERTICAL )
		
		self.m_staticText16 = wx.StaticText( self.m_panel5, wx.ID_ANY, u"Required Files List", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText16.Wrap( -1 )
		bSizer37.Add( self.m_staticText16, 0, wx.ALL, 5 )
		
		self.ctl_required = wx.TextCtrl( self.m_panel5, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, wx.TE_MULTILINE|wx.TE_WORDWRAP )
		bSizer37.Add( self.ctl_required, 1, wx.ALL|wx.EXPAND, 5 )
		
		bSizer34.Add( bSizer37, 1, wx.EXPAND, 5 )
		
		self.m_panel5.SetSizer( bSizer34 )
		self.m_panel5.Layout()
		bSizer34.Fit( self.m_panel5 )
		self.m_notebook1.AddPage( self.m_panel5, u"Resources", False )
		self.m_panel6 = wx.Panel( self.m_notebook1, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer40 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer41 = wx.BoxSizer( wx.VERTICAL )
		
		self.m_staticText17 = wx.StaticText( self.m_panel6, wx.ID_ANY, u"Usage Tips", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText17.Wrap( -1 )
		bSizer41.Add( self.m_staticText17, 0, wx.ALL, 5 )
		
		self.ctl_tips = wx.TextCtrl( self.m_panel6, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, wx.TE_MULTILINE|wx.TE_WORDWRAP )
		bSizer41.Add( self.ctl_tips, 1, wx.ALL|wx.EXPAND, 5 )
		
		bSizer40.Add( bSizer41, 1, wx.EXPAND, 5 )
		
		bSizer42 = wx.BoxSizer( wx.VERTICAL )
		
		self.m_staticText171 = wx.StaticText( self.m_panel6, wx.ID_ANY, u"Installation Instructions", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText171.Wrap( -1 )
		bSizer42.Add( self.m_staticText171, 0, wx.ALL, 5 )
		
		self.ctl_instructions = wx.TextCtrl( self.m_panel6, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, wx.TE_MULTILINE|wx.TE_WORDWRAP )
		bSizer42.Add( self.ctl_instructions, 1, wx.ALL|wx.EXPAND, 5 )
		
		bSizer40.Add( bSizer42, 1, wx.EXPAND, 5 )
		
		self.m_panel6.SetSizer( bSizer40 )
		self.m_panel6.Layout()
		bSizer40.Fit( self.m_panel6 )
		self.m_notebook1.AddPage( self.m_panel6, u"Instructions / Tips", False )
		self.m_panel7 = wx.Panel( self.m_notebook1, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer43 = wx.BoxSizer( wx.VERTICAL )
		
		self.m_staticText21 = wx.StaticText( self.m_panel7, wx.ID_ANY, u"List of files contained in the ZIP, including folder names and locations", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText21.Wrap( -1 )
		bSizer43.Add( self.m_staticText21, 0, wx.ALL, 5 )
		
		self.m_staticText22 = wx.StaticText( self.m_panel7, wx.ID_ANY, u"Select Parent Folder to List :", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText22.Wrap( -1 )
		self.m_staticText22.SetBackgroundColour( wx.SystemSettings.GetColour( wx.SYS_COLOUR_BTNHIGHLIGHT ) )
		
		bSizer43.Add( self.m_staticText22, 0, wx.ALL, 5 )
		
		ctl_inclusive_FilesChoices = []
		self.ctl_inclusive_Files = wx.ListBox( self.m_panel7, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, ctl_inclusive_FilesChoices, 0 )
		bSizer43.Add( self.ctl_inclusive_Files, 1, wx.ALL|wx.EXPAND, 5 )
		
		self.m_dirPicker = wx.DirPickerCtrl( self.m_panel7, wx.ID_ANY, wx.EmptyString, u"Select a folder", wx.DefaultPosition, wx.DefaultSize, wx.DIRP_DEFAULT_STYLE )
		bSizer43.Add( self.m_dirPicker, 0, wx.ALL|wx.EXPAND, 5 )
		
		self.m_panel7.SetSizer( bSizer43 )
		self.m_panel7.Layout()
		bSizer43.Fit( self.m_panel7 )
		self.m_notebook1.AddPage( self.m_panel7, u"Provided Files", False )
		self.m_panel8 = wx.Panel( self.m_notebook1, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer46 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer45 = wx.BoxSizer( wx.HORIZONTAL )
		
		m_storesChoices = [ u"RDNA", u"Renderosity", u"DAZ", u"Other" ]
		self.m_stores = wx.RadioBox( self.m_panel8, wx.ID_ANY, u"Include Licence", wx.DefaultPosition, wx.DefaultSize, m_storesChoices, 1, wx.RA_SPECIFY_COLS )
		self.m_stores.SetSelection( 2 )
		self.m_stores.Hide()
		
		bSizer45.Add( self.m_stores, 1, wx.ALL, 5 )
		
		self.m_staticText18 = wx.StaticText( self.m_panel8, wx.ID_ANY, u"This Will Be Copied to your Working Directory (the folder you chose at startup)", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText18.Wrap( -1 )
		bSizer45.Add( self.m_staticText18, 0, wx.ALL, 5 )
		
		bSizer46.Add( bSizer45, 0, wx.EXPAND, 5 )
		
		bSizer31 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_loadall = wx.Button( self.m_panel8, wx.ID_ANY, u"Load Old Data", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_loadall.Hide()
		
		bSizer31.Add( self.m_loadall, 0, wx.ALL, 5 )
		
		self.m_filePicker = wx.FilePickerCtrl( self.m_panel8, wx.ID_ANY, wx.EmptyString, u"Select a file", u"*.*", wx.DefaultPosition, wx.DefaultSize, wx.FLP_DEFAULT_STYLE )
		bSizer31.Add( self.m_filePicker, 1, wx.ALL|wx.EXPAND, 5 )
		
		bSizer46.Add( bSizer31, 0, wx.EXPAND, 5 )
		
		self.m_preview = wx.TextCtrl( self.m_panel8, wx.ID_ANY, wx.EmptyString, wx.DefaultPosition, wx.DefaultSize, wx.TE_MULTILINE|wx.TE_WORDWRAP )
		bSizer46.Add( self.m_preview, 1, wx.ALL|wx.EXPAND, 5 )
		
		self.m_panel8.SetSizer( bSizer46 )
		self.m_panel8.Layout()
		bSizer46.Fit( self.m_panel8 )
		self.m_notebook1.AddPage( self.m_panel8, u"Select Licence", False )
		self.m_panel71 = wx.Panel( self.m_notebook1, wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TAB_TRAVERSAL )
		bSizer35 = wx.BoxSizer( wx.VERTICAL )
		
		bSizer331 = wx.BoxSizer( wx.HORIZONTAL )
		
		self.m_staticText172 = wx.StaticText( self.m_panel71, wx.ID_ANY, u"Load Saved Data", wx.DefaultPosition, wx.DefaultSize, 0 )
		self.m_staticText172.Wrap( -1 )
		bSizer331.Add( self.m_staticText172, 0, wx.ALL, 5 )
		
		self.m_loadall = wx.FilePickerCtrl( self.m_panel71, wx.ID_ANY, wx.EmptyString, u"Select a file", u"*.csv", wx.DefaultPosition, wx.DefaultSize, wx.FLP_DEFAULT_STYLE )
		bSizer331.Add( self.m_loadall, 1, wx.ALL, 5 )
		
		bSizer35.Add( bSizer331, 0, wx.EXPAND, 5 )
		
		bSizer341 = wx.BoxSizer( wx.HORIZONTAL )
		
		bSizer341.AddSpacer( ( 0, 0), 1, wx.EXPAND, 5 )
		
		self.m_saveall = wx.Button( self.m_panel71, wx.ID_ANY, u"Save All Data", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer341.Add( self.m_saveall, 0, wx.ALL|wx.RIGHT, 5 )
		
		bSizer35.Add( bSizer341, 0, wx.EXPAND, 5 )
		
		self.m_panel71.SetSizer( bSizer35 )
		self.m_panel71.Layout()
		bSizer35.Fit( self.m_panel71 )
		self.m_notebook1.AddPage( self.m_panel71, u"Load / Save Data", False )
		
		bSizer1.Add( self.m_notebook1, 1, wx.EXPAND |wx.ALL, 5 )
		
		bSizer30.Add( bSizer1, 1, wx.EXPAND, 5 )
		
		bSizer322 = wx.BoxSizer( wx.HORIZONTAL )
		
		bSizer322.AddSpacer( ( 0, 0), 1, wx.EXPAND, 5 )
		
		self.generate = wx.Button( self, wx.ID_ANY, u"Generate", wx.DefaultPosition, wx.DefaultSize, 0 )
		bSizer322.Add( self.generate, 0, wx.ALL, 5 )
		
		bSizer30.Add( bSizer322, 0, wx.EXPAND, 5 )
		
		bSizer32 = wx.BoxSizer( wx.HORIZONTAL )
		
		bSizer30.Add( bSizer32, 0, wx.EXPAND, 5 )
		
		self.SetSizer( bSizer30 )
		self.Layout()
		
		self.Centre( wx.BOTH )
		
		# Connect Events
		self.m_save_details.Bind( wx.EVT_BUTTON, self.sub_saveprefs )
		self.m_mr.Bind( wx.EVT_RADIOBOX, self.sub_enable_res )
		self.m_dirPicker.Bind( wx.EVT_DIRPICKER_CHANGED, self.sub_listfiles )
		self.m_loadall.Bind( wx.EVT_BUTTON, self.sub_loadall )
		self.m_filePicker.Bind( wx.EVT_FILEPICKER_CHANGED, self.sub_loadall )
		self.m_loadall.Bind( wx.EVT_FILEPICKER_CHANGED, self.sub_loadall )
		self.m_saveall.Bind( wx.EVT_BUTTON, self.sub_saveall )
		self.generate.Bind( wx.EVT_BUTTON, self.sub_generate )
	
	def __del__( self ):
		pass
	
	# Virtual event handlers, overide them in your derived class
	def sub_enable_res(self, event):
		event.Skip()

	def sub_saveall(self, event):
		event.Skip()

	def sub_generate( self, event ):
		event.Skip()
	
	def sub_saveprefs( self, event ):
		event.Skip()

class readMe(Merchelper):
	def __init__(self):
		# Create Dictionary
		monthlist={ 1	:'January',
					2	:'February',
					3	:'March',
					4	:'April',
					5	:'May',
					6	:'June',
					7	:'July',
					8	:'August',
					9	:'September',
					10	:'October',
					11	:'November',
					12	:'December' }
		
		# Set up the user interface
		Merchelper.__init__(self, None)
		now = datetime.datetime.now()
		year = now.year
		month = now.month
		month = monthlist[month]
		day = now.day
		self.date=str(month)+' : '+str(year)
		self.ctl_creationDate.SetValue(self.date)
		# Set Global Variables
		self.config_path=None
		self.ReadMe=None
		self.workingFolder=self.getfolder(message='Select folder for ReadMe Location')
		self.fstring=[]
		# check prefs exist
		self.getprefs()

	def sub_enable_res(self, event=None):
		if self.m_mr.Selection==0:
			self.ctl_resources.Enable( True )
		else:
			self.ctl_resources.Enable( False )
			self.ctl_resources.SetValue('')

	def getprefs(self, event=None):
		config_name='readMe.cfg'
		if getattr(sys, 'frozen', False):
			application_path = os.path.dirname(sys.executable)
		elif __file__:
			application_path = os.path.dirname(__file__)
		cfg_location=poser.PrefsLocation()
		self.config_path = os.path.join(cfg_location, config_name)
		if os.path.exists(self.config_path):
			getpref=open(self.config_path,'r')
			data=getpref.readlines()
			getpref.close()
			lines = [line.strip() for line in data]
			c=0
			for line in lines:
				if c==0:
					self.ctl_artName.SetValue(line)
				else:
					self.ctl_Email.SetValue(line)
				c+=1

	def sub_saveprefs(self, event=None):
		# cfg_location=poser.PrefsLocation()
		# config_name='readMe.cfg'
		name=self.ctl_artName.Value
		email=self.ctl_Email.Value
		if name == '' or name == None:
			self.error='Name is blank'
			self.ShowAlert('Data Not Saved')
			return False
		if email == '' or email == None:
			self.error='E-Mail is blank'
			self.ShowAlert('Data Not Saved')
			return False
		if self.config_path==None or self.config_path=='':
			self.error='No Configuration File'
			self.ShowAlert('Creating Configuration File')
		setprefs=open(self.config_path, 'w')
		setprefs.write(name+'\n')
		setprefs.write(email+'\n')
		setprefs.close()

	def sub_generate(self, event=None):
		'''Set the ReadMe Variables'''
		pName=self.ctl_productName.Value
		cdate=self.ctl_creationDate.Value
		name=self.ctl_artName.Value
		email=self.ctl_Email.Value
		Description=self.ctl_product_description.Value
		CompatibilityList=[]
		for ctl in self.controls():
			if ctl.IsChecked():
				if ctl.Label.startswith('P') and not ctl.Label=='PhotoShop' and not ctl.Label=='Paint Shop Pro' and not ctl.Label == 'PC':
					CompatibilityList.append('Poser '+ctl.Label[1:])
				elif ctl.Label.startswith('V'):
					CompatibilityList.append('Vue '+ctl.Label[1:])
				else:
					CompatibilityList.append(ctl.Label)
		
		other = self.ctl_other.Value
		CompatibilityList.append(other)
		
		mr=self.m_mr.Selection
		if self.m_mr.Selection==0:
			mrtext=self.ctl_resources.Value
		else:
			mrtext=''
		req=self.ctl_required.Value

		tips=self.ctl_tips.Value
		Instructions=self.ctl_instructions.Value
		# file_list=self.ctl_inclusive_Files()

		'''write the ReadMe File'''
		line = '*'*50
		dash = '-'*50
		filepath=self.workingFolder
		if self.ctl_productName.Value=='' or self.ctl_productName==None:
			self.ctl_productName.SetValue('New_Project')
		if self.m_include.IsChecked():
			file=filepath+os.path.sep+self.ctl_artName.Value+'_'+self.ctl_productName.Value+'_ReadMe.txt'
		else:
			file=filepath+os.path.sep+self.ctl_productName.Value+'_ReadMe.txt'
		self.error='Readme File Saved to' 
		self.ShowAlert(file)
		makeit=open(file, 'w')
		makeit.write(line+'\n')
		spc=' '
		makeit.write('*Product Name'+spc*7+':'+pName+'\n')
		makeit.write('*Author'+spc*13+':'+name+'\n')
		makeit.write('*Author E-Mail'+spc*6+':'+email+'\n')
		makeit.write('*Date'+spc*15+':'+cdate+'\n')
		makeit.write(line+'\n')
		makeit.write('\n')
		makeit.write('Product Description :'+'\n')
		makeit.write(dash+'\n')
		makeit.write('\n')
		makeit.write(Description+'\n')
		makeit.write(dash+'\n')
		makeit.write('\n')
		makeit.write('System / Software Requirements :'+'\n')
		makeit.write(dash+'\n')
		makeit.write('\n')
		for item in CompatibilityList:
			makeit.write(item+' '+'\n')
		makeit.write(self.ctl_required.Value+'\n')
		makeit.write(dash+'\n')
		makeit.write('\n')
		makeit.write('Installation Instructions :'+'\n')
		makeit.write(dash+'\n')
		makeit.write(Instructions+'\n')
		makeit.write('\n')
		makeit.write('Merchant Resources Used :'+'\n')
		makeit.write(dash+'\n')
		makeit.write(mrtext+'\n')
		makeit.write('\n')
		makeit.write('Usage Tips or Limitations :'+'\n')
		makeit.write(dash+'\n')
		makeit.write(tips+'\n')
		makeit.write('\n')
		makeit.write('Files Included in the Product :'+'\n')
		makeit.write(dash+'\n')
		for i in range(self.ctl_inclusive_Files.GetCount()):
			filestring=self.ctl_inclusive_Files.GetString(i)
			makeit.write(filestring+'\n')
		makeit.write('\n\nThe developer owns the copyright and/or has the rights to distribute all of the content contained within this ZIP file.')
		makeit.close()

	def controls(self):
		return (
			self.m_poser4, 
			self.m_poser5, 
			self.m_poser6, 
			self.m_poser7, 
			self.m_poser8, 
			self.m_poser9, 
			self.m_poser10,
			self.m_ds3,
			self.m_ds4,
			self.m_bryce,
			self.m_vue5,
			self.m_vue6,
			self.m_vue7,
			self.m_vue8,
			self.m_vue9,
			self.m_vue10,
			self.m_vue11,
			self.m_photoshop,
			self.m_psp,
			self.m_PC,
			self.m_MAC
			)

	def forms(self):
		return (
			self.ctl_artName,
			self.ctl_Email,
			self.ctl_creationDate,
			self.ctl_productName,
			self.ctl_other,
			self.ctl_resources,
			self.ctl_required,
			self.ctl_product_description,
			self.ctl_tips,
			self.ctl_instructions,
			self.ctl_inclusive_Files
			)

	def sub_saveall(self, event=None):
		if not self.ctl_productName.Value=='' and not self.ctl_productName.Value==None:
			databack=self.getfolder(message='Select folder for backupdata Location')
			databack=os.path.join(databack,self.ctl_productName.Value+'.csv')
			c = csv.writer(open(databack, 'wb'))
			c.writerow([self.ctl_artName.Value])
			c.writerow([self.ctl_productName.Value])
			c.writerow([self.ctl_Email.Value]) 
			c.writerow([self.ctl_creationDate.Value]) 
			c.writerow([self.ctl_product_description.Value])
			for ctl in self.controls():
				if ctl.IsChecked():
					c.writerow([1])
				else:
					c.writerow([0])
			c.writerow ([self.ctl_other.Value])			
			if self.m_mr.Selection == 0:
				c.writerow([0])
			else:
				c.writerow([1])
			c.writerow([self.ctl_resources.Value])
			c.writerow([self.ctl_required.Value])
			c.writerow([self.ctl_tips.Value])
			c.writerow([self.ctl_instructions.Value])
			for i in range(self.ctl_inclusive_Files.GetCount()):
				filestring=self.ctl_inclusive_Files.GetString(i)
				c.writerow([filestring])
			c.writerow([self.m_preview.Value])

	def stripstring(self, old, row):
		subst = re.sub(r''+old,'',row)
		return subst

	def sub_loadall(self, event=None):
		databack=self.m_loadall.GetPath()
		cr = csv.reader(open(databack,'rb'))
		row=[]

		for r in cr:
			r=str(r)			
			r =self.stripstring('\[', r)
			r =self.stripstring('\]', r)
			r =self.stripstring('\'', r)
			row.append(r)

		self.ctl_artName.SetValue(str(row[0]))
		self.ctl_Email.SetValue(str(row[2]))
		self.ctl_productName.SetValue(str(row[1]))
		self.ctl_creationDate.SetValue(str(row[3]))
		self.ctl_product_description.SetValue(str(row[4]))
		self.ctl_other.SetValue(str(row[26]))
		c=5
		for ctl in self.controls():
			if row[c] == '1':
				ctl.SetValue(True)
			else:
				ctl.SetValue(False)
			c+=1
		
		if row[27]=='0':
			self.m_mr.SetSelection(0)
			self.sub_enable_res()
		else:
			self.m_mr.SetSelection(1)
		self.ctl_resources.SetValue(row[28])
		self.ctl_required.SetValue(row[29])
		self.ctl_tips.SetValue(row[30])
		self.ctl_instructions.SetValue(row[31])
		for files in range(32, len(row)-2):
			self.ctl_inclusive_Files.Append(row[files])
		self.m_preview.SetValue(row[len(row)-1])

	def loadlicence(self, file=None):
		file=self.m_filePicker.GetPath()
		licence=open(file, 'r')
		lines=licence.readlines()
		licence.close()
		if ('rdna') in file.lower():
			text=self.replaceit(file, 'ENTER EMAIL(s) HERE',self.ctl_Email.Value)
			text=self.replaceit(file, '[ENTER NAME(s) HERE]',self.ctl_artName.Value)
		licence=open(file, 'r')
		lines=licence.readlines()
		licence.close()
		lines=''.join(lines)
		self.m_preview.SetValue(lines)
		path=self.workingFolder
		licencename=file.split(os.path.sep)
		licence = ''.join(licencename[len(licencename)-1:len(licencename)])
		licence = path+os.path.sep+licence
		oldpath=file 
		newpath=licence
		if not os.path.exists(newpath):
			shutil.copyfile(oldpath,newpath)
		else:
			self.error='file exists'
			self.ShowAlert('Cannot Create File')

	def replaceit(self, file, old=None, new=None):
		for line in fileinput.FileInput(file,inplace=1):
			line = line.replace(old,new)
			print line,

	#get working folder
	def getfolder(self, parentDialog=0, message=None):
		startDir = os.path.join(poser.Libraries()[0], 'runtime') 
		workDir = poser.DialogDirChooser(parentDialog,message,startDir)
		workDir.Show()
		wD = workDir.Path()
		return wD

	def sub_listfiles(self, event=None):
		self.fstring=[]
		self.ctl_inclusive_Files.Clear()
		newpart=''
		path=self.m_dirPicker.GetPath()
		parent_folder = os.path.dirname(path)
		contents = os.walk(path)
		sep=os.path.sep
		for root, folders, files in contents:
			for folder_name in folders:
				absolute_path = os.path.join(root, folder_name)
				relative_path = absolute_path.replace(parent_folder + '\\',                                                      '')
				#self.ctl_inclusive_Files.Append(relative_path)
			for file_name in files:
				if not file_name.endswith('.ini') and not file_name.lower()=='.ds_store':
					absolute_path = os.path.join(root, file_name)
					relative_path = absolute_path.replace(parent_folder + '\\',                                                      '')
					if not 'runtime' in relative_path.lower():
						if 'templates' in relative_path.lower():
							relative_path='Templates'+os.path.sep+os.path.basename(absolute_path)
						elif 'documentation' in relative_path.lower():
							relative_path='Documentation'+os.path.sep+os.path.basename(absolute_path)
						else:
							basename=os.path.basename(absolute_path)
							sections=['character'+sep,'pose'+sep,'face'+sep,'hair'+sep,'hand'+sep, \
							'props'+sep,'light'+sep,'camera'+sep,'materials'+sep,'scene'+sep,]
							osections=['geometries'+sep,'textures'+sep,'python'+sep,'templates'+sep]
							for sect in sections:
								if sect in relative_path.lower():
									relative_path='Runtime'+sep+'Libraries'+sep+relative_path
							for sect in osections:
								if sect in relative_path.lower():
									relative_path='Runtime'+sep+relative_path
					if not 'documentation' in relative_path.lower() and not 'runtime' in relative_path.lower() and not 'templates' in relative_path.lower():
						relative_path=basename

					if 'runtime' in relative_path.lower():
						r_path=relative_path[0:len(relative_path)-len(os.path.basename(relative_path))]
						basename=os.path.basename(relative_path)
						f_name=r_path.split(os.path.sep)
						flist=[]
						for x in range(len(f_name)):
							if not f_name[x].lower() == 'runtime':
								flist.append(x)
							else:
								break
						for x in flist:
							try:
								f_name.remove(f_name[x])
							except:
								pass
						fname=''
						for x in range(len(f_name)):
							fname=os.path.join(fname, f_name[x])
						relative_path=fname+basename
					just_path=self.sorted_file_list(relative_path)

	def sorted_file_list(self, relative_path):
		rel=relative_path[0:len(relative_path)-len(os.path.basename(relative_path))]
		if not rel in self.fstring:
			self.fstring.append(rel)
			self.ctl_inclusive_Files.Append(' ')
			self.ctl_inclusive_Files.Append(rel)
			self.ctl_inclusive_Files.Append('-'*50)

		self.ctl_inclusive_Files.Append(os.path.basename(relative_path))

	def ShowAlert(self, alertmessage, error=None, title=None):
		APPNAME=u'structure\'s ReadMe Generator ©2014'
		title=self.error
		if title == None: title = '%s ' % APPNAME
		msg = wx.MessageDialog(None, alertmessage, caption=title, style=wx.OK|wx.STAY_ON_TOP)
		msg.ShowModal()	

	def __del__( self):
		
		marker=poser.TempLocation()
		marker=marker+os.path.sep+'rmg.tmp'
		try:
			os.remove(marker)
		except:
			pass

		poser.Scene().ClearEventCallback()
		self.Close(True)

# Main is used to launch the user interface
class Main(object):
	def __init__(self):
		ex=False
		temp=poser.TempLocation()
		marker=temp+os.path.sep+'rmg.tmp'
		if not(os.path.isfile(marker)):
			try:
				fNm=open(marker,'w')
				fNm.write(u'str-run')
			except IOError:
				message='Undetermined IO Error :'
				caption='IOError'
				parent=None
				dlg = wx.MessageDialog(parent, message, caption, wx.OK | wx.ICON_WARNING)
				dlg.ShowModal()
				dlg.Destroy()
		else:
			message='ReadMe Generator is already running :'
			caption='File Error :'
			parent=None
			dlg = wx.MessageDialog(parent, message, caption, wx.OK | wx.ICON_WARNING)
			dlg.ShowModal()
			dlg.Destroy()
			sourcepath = os.path.join(poser.Libraries()[0], 'runtime','python','poserscripts','jlk','utils','readMeGenerator.pyc') 
			#sourcepath = os.path.join(poser.Libraries()[0], 'runtime','python','poserscripts','scriptsmenu','! jlk','utils','readMeGenerator.py') 
			try:
				execfile(sourcepath)
			except SystemExit:
				ex=True
			except IOError:
				ex=True
		if not ex:
			main = readMe()
			main.SetTitle(u'ReadMe Generator : structure © 2014')
			main.SetSize((650,450))
			main.Show()

# Run the Script
Main()